# TFLAT -- Divide TRES images by pixel normalization file from tmakeflat
#          (apflatten), saving original files in Unflat/
# By Doug Mink, SAO Telescope Data Center
# February 22, 2008

procedure tflat (images)

string	images = ""	{prompt="Input multispec image(s) to correct"}
string	normfile=""	{prompt="Pixel to pixel tmakeflat normalization file"}
string	normdir="tresdata$"	{prompt="Directory for normalization file"}
bool	deltemp = no	{prompt="Delete temporary files (y or n)"}
bool	saveold = yes	{prompt="Save original file to Nonorm/ (y or n)"}
bool	verbose = yes	{prompt="Log progress (y or n)"}

struct	*flatlist

begin
	bool vb, sv
	file imin, imnorm, templist, ndir
	string ims

	ims = images
	vb = verbose
	imnorm = normfile
	ndir = normdir
	fixdir (ndir)
	ndir = fixdir.newdir
	if (ndir == "") {
	    ndir = "tresdata$"
	    }

#  Make temporary list of input files
        templist = mktemp ("tempflat") // ".list"
        files (ims, >templist)

# Flatten images from list one at a time
        flatlist = templist
        while (fscan (flatlist,imin) != EOF) {
	    tflat1 (imin, normfile=imnorm, normdir=ndir, saveold=sv, verbose=vb)
	    }

	if (deltemp) {
	    delete (templist)
	    }
end

# Oct  2 2007	New task based on hectospec.hflat
# Oct 10 2007	Fix bug so that normfile name is always created if normfile=""
# Dec 19 2007	Default data directory to tresdata$

# Jan 10 2008	Rename tresfib trsfib
# Jan 17 2008	Update normfile and normdir prompts
# Feb 11 2008	Change name of temporary file from flatlist* to tempflatlist*
# Feb 15 2008	Do not try to flatten dark or bias images
# Feb 22 2008	Move actual image flattening to TFLAT1
