# tres/Scripts/tharlist.cl
# May 23, 2008
# By Doug Mink

# THARLIST - List COMP images by exposure time (optional), aperture size, fiber(s), and binning

procedure tharlist ()

string  images=""       {prompt="Images to check"}
string	apfib=""	{prompt="Select fiber (s m l) binning (b) ap (1 2 3)"}
string	fibcode=""	{prompt="FIBSIZE value to match: null=all s=1.4 m=2.3 l=3.2"}
int	binning=0	{prompt="BINNING value to match: 0=all 1 2"}
string	apertures="123"	{prompt="Apertures to use: null=all 1 2 3 12 123"}
string	exptime=""	{prompt="Exposure time to list (0.0 = all)"}
bool	overwrite=no	{prompt="Overwrite existing list files (yes or no)"}
bool	deltemp=yes	{prompt="Delete temporary files (yes or no)"}
bool    verbose=yes	{prompt="Print process progress (yes or no)"}
bool    debug=no	{prompt="Print debugging info (yes or no)"}

begin

    string ims, aps, afx, exp, outfile
    bool vb, ow, db, dt

    exp = exptime
    vb = verbose
    db = debug
    dt = deltemp
    ow = overwrite

    ims = images
    if (ims == "")
	ims = "1-250"

    afx = apfib
    if (afx != "") {
	trsdecode (afx)
	binning = trsdecode.binning
	fibcode = trsdecode.fibcode
	aps = trsdecode.apertures
	}
    else {
	aps = apertures
	if (aps == "")
	    aps = "123"
	}
    if (db)
	print ("THARLIST: ap =",aps," fiber size= ", fibcode," binning= ",binning)

# Largest fiber comparison lamp images
    if (fibcode	== "" || fibcode == "l") {
	if (binning == 1 || binning == 0) {
	    if (vb) print ("Large fiber unbinned files")
	    if (aps == "1" || aps == "2" || aps == "12" || aps == "123") {
		if (exp == "")
		    outfile = "compl12.list"
		else
		    outfile = "compl12_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="CCN",apfib="l1",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    if (aps == "3" || aps == "123") {
		if (exp == "")
		    outfile = "compl3.list"
		else
		    outfile = "compl3_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="NNC",apfib="l3",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    }
	if (binning == 2 || binning == 0) {
	    if (vb) print ("Large fiber binned files")
	    if (aps == "1" || aps == "2" || aps == "12" || aps == "123") {
		if (exp == "")
		    outfile = "complb12.list"
		else
		    outfile = "complb12_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="CCN",apfib="lb1",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    if (aps == "3" || aps == "123") {
		if (exp == "")
		    outfile = "complb3.list"
		else
		    outfile = "complb3_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="NNC",apfib="lb3",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    }
	}

# Medium fiber comparison lamp images
    if (fibcode == "" || fibcode == "m") {
	if (binning == 1 || binning == 0) {
	    if (vb) print ("Medium fiber unbinned files")
	    if (aps == "1" || aps == "2" || aps == "12" || aps == "123") {
		if (exp == "")
		    outfile = "compm12.list"
		else
		    outfile = "compm12_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="CCN",apfib="m1",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    if (aps == "3" || aps == "123") {
		if (exp == "")
		    outfile = "compm3.list"
		else
		    outfile = "compm3_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="NNC",apfib="m3",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    }
	if (binning == 2 || binning == 0) {
	    if (vb) print ("Medium fiber binned files")
	    if (vb) print ("apertures ",aps)
	    if (aps == "1" || aps == "2" || aps == "12" || aps == "123") {
		if (exp == "")
		    outfile = "compmb12.list"
		else
		    outfile = "compmb12_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="CCN",apfib="mb1",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    if (aps == "3" || aps == "123") {
		if (exp == "")
		    outfile = "compmb3.list"
		else
		    outfile = "compmb3_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="NNC",apfib="mb3",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    }
	}

# Small fiber comparison lamp images
    if (fibcode == "" || fibcode == "s") {
	if (binning == 1 || binning == 0) {
	    if (vb) print ("Small fiber unbinned files")
	    if (aps == "1" || aps == "2" || aps == "12" || aps == "123") {
		if (exp == "")
		    outfile = "comps12.list"
		else
		    outfile = "comps12_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="CCN",apfib="s1",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    if (aps == "3" || aps == "123") {
		if (exp == "")
		    outfile = "comps3.list"
		else
		    outfile = "comps3_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="NNC",apfib="s3",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    }
	if (binning == 2 || binning == 0) {
	    if (vb) print ("Small fiber binned files")
	    if (aps == "1" || aps == "2" || aps == "12" || aps == "123") {
		if (exp == "")
		    outfile = "compsb12.list"
		else
		    outfile = "compsb12_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="CCN",apfib="sb1",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    if (aps == "3" || aps == "123") {
		if (exp == "")
		    outfile = "compsb3.list"
		else
		    outfile = "compsb3_" // exp // ".list"
		if (!access (outfile) || ow)
		    trslist (ims,fibkey="NNC",apfib="sb3",outlist=outfile,exptime=exp,overwrite=ow,deltemp=dt,verbose=vb,debug=db)
		else if (debug)
		    print ("THARLIST: ",outfile," already exists")
		}
	    }
	}

end

# Jan 11 2008	New task
# Apr 30 2008	Add fibsize and binning parameters to speed processing
# May 12 2008	Add apertures parameter to speed processing
# May 16 2008	Hide images parameter so it is not prompted for
# May 16 2008	Add overwrite parameter to delete and recreate output files
# May 19 2008	Select in APLIST using apfib parameter, not binning and fibsize
# May 19 2008	Add selection by exposure time and add it to list file name if present
# May 20 2008	Rename from tcompfiles to tharlist
# May 20 2008	Change apertures from int to string
# May 21 2008	Change tdecomp() to trsdecode() and fibsize to fibcode
# May 23 2008	Print message in debug mode if any list file is not written
