# File hectospec/tharplot.cl
# August 13, 2008
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# THARPLOT -- Use rvsao.emsao to plot emission and absorption lines
#	      already found in a spectrum file or list of spectra

procedure tharplot (spectra, order)

string	spectra=""	{prompt="RFN or file"}
string  order="1"	{prompt="Spectrum order(s) to plot"}

string  specdir=""	{prompt="Directory for spectrum to plot"}
string  ablines=""	{prompt="File of absorption lines to label"}
string  emlines="tharlines.dat"	{prompt="File of emission lines to label"}
string  emcombine="tharcomb.dat" {prompt="File of emission lines to label"}
string  linedir="tres$lib/" {prompt="Directory for lines to label"}
bool	debug=no	{prompt="Run EMSAO in debugging mode (yes or no)"}

begin
string	eml

if (!defpac ("rvsao"))
    rvsao (motd=no)

eml = "+" // emlines

emsao (spectra,specnum=order,specdir=specdir,vel_init="emission",czguess=0.0,linefit=no,curmode=yes,ablines=ablines,emlines=eml,emcombine=emcombine,emsearch="",linedir=linedir,logfiles="",save_vel=no,vel_plot="emission",displot=yes,dispmode=3,debug=debug)
 
end

# Jul 21 2008	New script based on rvsao.qplot
# Aug  8 2008	Add emcombine parameter and fix linedir default and set it
# Aug 13 2008	Add emsearch to argument list
