# File tres/Scripts/tquick.cl
# By Doug Mink
# September 19, 2008

# TQUICK -- Set instrument and date directories for TRES listing and quick look

procedure tquick

string	instdir="/tres/" {prompt="Root directory with raw data"}
string	quickdir="home$tresq/"	{prompt="Root directory for quicklook data"}
int	lastseq=200	{prompt="First sequence number for summed spectra"}
bool	deltemp=yes	{prompt="Delete temporary list file (yes or no)"}
bool	verbose=yes	{prompt="Print table of image parameters (yes or no)"}

struct *dirfiles

begin
    bool vb
    int ismax, iseq
    file ddir, idir, datadir, qdir, templist, imin
    string rawfiles

    vb = verbose

    fixdir (instdir)
    idir = fixdir.newdir

    fixdir (quickdir)
    qdir = fixdir.newdir

# Get current date in data directory format
    gettime (0.0)
    ddir = gettime.datadir

    datadir = idir // ddir
    if (!access (datadir)) {
	print ("TRSDATE: ",datadir, " not found")
	return
	}

    qtres.datedir = ddir
    qtres.instdir = idir
    ctres.datedir = ddir
    ctres.instdir = idir
    trsproc.datedir = ddir
    trsproc.instdir = idir
    ftres.datedir = ddir
    ftres.instdir = idir
    ttres.datedir = ddir
    ttres.instdir = idir
    trslist.datedir = ddir
    trslist.instdir = idir
    trsgroup.datedir = ddir
    trsgroup.instdir = idir
    trsfiles.datedir = ddir
    trsfiles.instdir = idir
    trsfiles.adddate = no


    if (!access (qdir)) {
	mkdir (qdir)
	if (!access (qdir)) {
	    print ("TRSDATE: ",qdir, " cannot be created")
	    return
	    }
	}
    qdir = qdir // ddir
    if (!access (qdir)) {
	mkdir (qdir)
	if (!access (qdir)) {
	    print ("TRSDATE: ",qdir, " cannot be created")
	    return
	    }
	}
    cd (qdir)

    ismax = lastseq
    rawfiles = idir // ddir // "/0*.fits"
    templist = mktemp ("tempfile") // ".list"
    files (rawfiles, >templist)
    dirfiles = templist
    while (fscan (dirfiles, imin) != EOF) {
	filename (imin)
	iseq = int (substr (filename.filename,1,4))
	if (iseq > ismax)
	    ismax = iseq
	}

    trssum.sumseq = ismax + 1

    if (vb) {
	print ("Read from ",datadir,", write to ",qdir)
	print ("Current working directory is ",qdir)
	}

    if (deltemp) {
	delete (templist)
	dirfiles = ""
	}
end

# Sep 19 2008	New program based on trsdate
